#!/usr/bin/env python

import os, sys, glob, shutil

from distutils.core import setup, Extension

VERSION = open ("VERSION").readline ().strip ()

def RemoveDir (d):
    for root, dirs, files in os.walk (d, topdown=False):
        for name in files:
            os.remove (os.path.join (root, name))
        for name in dirs:
            os.rmdir (os.path.join (root, name))
    os.rmdir (d)

op = None
for x in sys.argv [1:]:
    if x == "clean" or x == "install" or x == "build":
        op = x

# Create mo files:
mofiles = []
for pofile in glob.glob('po/*.po'):
    lang = os.path.splitext (os.path.basename (pofile)) [0]
    # Piggyback on the lib/ directory used by setup()
    path = "build/locale/" + lang
    if not os.path.isdir (path):
        os.makedirs (path, 0755)
    mofile = path + "/usbmode.mo"
    if op == "install" or op == "build":
        print "Generating", mofile
        os.system("msgfmt %s -o %s" % (pofile, mofile))
    mofiles.append (('share/locale/' + lang + '/LC_MESSAGES', [mofile]))

# Patch module version in __init__.py
ct = open ("usbmode").readlines ()
for ln in range (0, len (ct)):
    if ct [ln].find ("VERSION =") >= 0:
        ct [ln] = "VERSION = \"%s\"\n" % VERSION
open ("usbmode", "w").writelines (ct)

setup (name = 'usbmode',
        version = VERSION,
        description = 'A simple Maemo tool for switching USB controller mode',
        author = 'Andrew Zabolotny',
        author_email = 'zap@homelink.ru',
        license = 'GPL',
        platforms = ['Unix'],
        scripts = ['usbmode'],
        data_files = [
            ('share/usbmode', ['share/usb-large-OTG.png', 'share/usb-large-female-A.png', 'share/usb-large-male-A.png']),
            ('share/applications/hildon', ['share/usbmode.desktop']),
            ('share/icons/hicolor/64x64/apps', ['share/usbmode.png']),
            ('../etc/sudoers.d', ['share/usbmode.sudoers']),
            ] + mofiles,
        )

if op == "clean":
    if os.path.isdir ("build/locale"):
        RemoveDir ("build/locale")
